#include<stdio.h>
#include<string.h>
#include<stdlib.h>

typedef struct _red{
  char* r;
  struct _red *next;
}red;

void invertiraj(FILE *in, FILE *out)
{
  char sep, rijec[32], *redak=malloc(sizeof(char));
  char sepstr[]=" "; /*sepstr je string konstantne duljine (1+1 za '\0'), a u njega
                      cemo spremati spearator (razmak ili novi red). Buduci da cemo
                      koristiti string specificne funckije, trebamo string.*/
  red *lista=NULL, *temp;

  *redak='\0'; //pocetna vrijednost retka je nulstring
  while(fscanf(in,"%s%c",rijec,&sep)>0){
    redak=(char*)realloc(redak, strlen(redak)+strlen(rijec)+2); //2=1+1 (mjesto za separator i kraj '\0')
    sepstr[0]=sep;

    strcat(rijec,sepstr);
    strcat(redak,rijec);

    if(sep=='\n'){ //ovo je znak da smo zavrsili s citanjem tog retka
      temp=lista;
      lista=malloc(sizeof(red));
      lista->r=redak;
      lista->next=temp;

      /*ponistavanje retka*/
      redak=malloc(1);
      *redak='\0';
    }
  }

  /*Upisivanje u datoteku out*/
  while((temp=lista)){
    fprintf(out,"%s",temp->r);
    free(temp->r); //oslobadjamo dinamicki zauzetu memoriju za redak
    lista=temp->next;
    free(temp); //oslobadjamo dinamicki zauzetu memoriju za cvor temp
  }
}

int main(void){
  FILE*in=fopen("tekstualne_datoteke/redom.txt","rt"), *out=fopen("tekstualne_datoteke/obrnutimredom.txt","wt");
  if(!in||!out)
    return printf("Problem s otvaranjem\n");

  invertiraj(in,out);

  return 0;
}

