#include<stdio.h>
#include<string.h>
#include<stdlib.h>

typedef struct{
  char ime[51],prezime[51];
  char*ocjene;
}student;


/*pisemo kod prilagodjen slucaju kad bismo imali niz datoteka*/
int main(void){
  const char* datoteke[]={"tekstualne_datoteke/ma.txt",
    "tekstualne_datoteke/la.txt"};
  char im[51],prez[51],oc;
  unsigned brdat=sizeof(datoteke)/sizeof(*datoteke), cap=0, step=1, n=0, i, j, k;
  student* popis=NULL;

  FILE *out=fopen("tekstualne_datoteke/sve.txt","wt");

  for(i=0; i<brdat; i++){ //prilagodjeno nizu datoteka
    FILE *in=fopen(datoteke[i],"rt"); //otvaramo i-tu datoteku za citanje
    if(!in) return printf("Problem: %s\n", datoteke[i]);

    while(fscanf(in," %[^;];%[^;];%c", im,prez,&oc)>0){ //citanje iz datoteke
      int nasao=0;
      /*trazmi jesmo li vec tog studenta unijeli*/
      for(j=0; j<n; j++){
        if(!strcmp(popis[j].ime,im)
         &&!strcmp(popis[j].prezime,prez)){
          nasao=1;
          break;
        }
      }
      if(!nasao){
        /*da ne alociramo u svakom koraku memoriju (cap je trenutna kolicina zauzete memorije)*/
        if(++n>cap)
          popis=(student*)realloc(popis,(cap+=step*=2)*sizeof(student));
        strcpy(popis[j].ime,im);
        strcpy(popis[j].prezime,prez);
        popis[j].ocjene=malloc(brdat*sizeof(char)); //sizeof(char)=1 pa se to moze i izostaviti; prilagodjeno nizu datoteka
        for(k=0; k<brdat; k++)
          popis[j].ocjene[k]='-'; //pocetna vrijednost ocjena je -, a onda poslije - mijenjamo u odgovarajuci broj
      }
      popis[j].ocjene[i]=oc;
    }
    fclose(in);
  }

  /*sortiranje*/
  for(i=0;i<n;++i)
    for(j=0;j<i;++j){
      int key1=strcmp(popis[i].prezime,popis[j].prezime);
    if(key1<0||(!key1 && strcmp(popis[i].ime,popis[j].ime)<0)){
      student tmp=popis[i];
      popis[i]=popis[j];
      popis[j]=tmp;
    }
  }

  if(!out)return printf("Problem: tekstualne_datoteke/sve.txt\n");

  /*Pisanje po datoteci sve.txt*/
  for(i=0; i<n; i++){
    fprintf(out,"%s;%s", popis[i].ime,popis[i].prezime);
    for(k=0; k<brdat; k++)
      fprintf(out,";%c",popis[i].ocjene[k]);
    fprintf(out,"\n");
  }
  fclose(out);

  for(i=0;i<n;++i) free(popis[i].ocjene);
  free(popis);

  return 0;
}
